// test.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <stdio.h>
#include "RSAEnc.h"
#include "ET199_32.h"

#pragma comment(lib, "RSAEnc.lib")
#pragma comment(lib, "ET199_32S.lib")


//ʾв1024λRSAԿԣԿnΪ128ֽڣeΪ65537һμӽֻ128ֽڣݳȳ128ֽֿ
//ֿԲμET199๦_ƪ6.4
int main(int argc, char* argv[])
{
	
	/*----------һ̣ӦйԿܣET199˽Կ----------------*/

	////////////////////////////////////ʹùԿнм////////////////////////////
	//ԭ
	printf("/*----------һ̣ӦйԿܣET199˽Կ----------------*/\n");
	
	BYTE pbPlainData[128] = {0};

	for(int i=0; i<128; ++i)
	{
		pbPlainData[i] = i;
	}


	//ʹùԿʱҪעܵݲܴڹԿnֵ
	//ݵĵһֽڣܴڹԿnĵһֽ
	//ע͵0xB5ʹڹԿе0xB4ôʱǲɹ
	//pbPlainData[0] = 0xB5; 

	//Կnֵ128ֽ
	//1002.pubļУ
	//ǰ4ֽڣ0-3ǹԿȣ00 00 00 80Ϊ128ֽ
	//128ֽڣ4131ΪԿnֱֵӷŵ
	//ٺ4ֽڣ132-135Ϊֵ
	//4ֽڣ136139ǹԿeֵ00 01 00 01Ϊ65537ҪעʾеRSAData.dllֻ֧eΪ65537ֵ֧
	BYTE pbModulus[128] = {
		0xB4, 0x51, 0x64, 0x1C, 0x39, 0xC7, 0x8F, 0x51, 0xB5, 0x36, 0x30, 0xA1, 0x7F, 0xBE, 0x70, 0xB0,
		0xBE, 0x3A, 0x87, 0x3F, 0x78, 0x50, 0x20, 0x57, 0xFD, 0xDB, 0xD7, 0x6B, 0x6E, 0x4B, 0x9E, 0x3A,
		0xE7, 0x8A, 0xA5, 0x8F, 0x7A, 0x51, 0x22, 0x4A, 0xC3, 0x64, 0x5D, 0x84, 0xA7, 0xB2, 0x10, 0xE1,
		0x1B, 0x32, 0x67, 0x95, 0x1F, 0xB4, 0x62, 0x71, 0x8A, 0xA6, 0x3D, 0x35, 0x9B, 0x52, 0xC5, 0x4A,
		0x2A, 0xA2, 0x86, 0xB2, 0x55, 0x13, 0x90, 0xDB, 0x5A, 0x0E, 0xE0, 0xA4, 0x71, 0x0C, 0x09, 0xF6,
		0x3B, 0x21, 0x95, 0x35, 0x29, 0xC4, 0x7E, 0xF8, 0x3B, 0xA9, 0x6C, 0x4E, 0x61, 0xC8, 0x84, 0x79,
		0xDC, 0x8F, 0x5F, 0x0E, 0x1B, 0xE2, 0xF8, 0x72, 0xC2, 0x46, 0x25, 0x21, 0x03, 0xBE, 0x1A, 0x80,
		0x6A, 0xAA, 0x17, 0x37, 0xCE, 0x19, 0x9D, 0x14, 0x49, 0x98, 0xE2, 0x98, 0x16, 0x3C, 0x3A, 0xB9	
	};

	//ʹùԿм
	//RSAData˵
	//һԿnָ
	//ڶԿĳȣֻ51210242048ʹ1024
	//ΪģΪ
	//ĸݳȣ1024ĹԿֻ128
	//Ҫرע⣬ӿֹֻ֧ԿeֵΪ65537֧eֵĹԿ
	long ret = RSAData(pbModulus,1024,pbPlainData,128);
	if(ret == 0)
	{
		printf("йԿܽ\n");
		for(i=0; i<128; ++i)
		{
			if(i%16==0)
				printf("\n");
			printf("%02X ", pbPlainData[i]);
		}
	}
	else
	{
		printf("RSAData Error:0x%08X\n", ret);
	}

	
	////////////////////////////////////ʹ˽ԿET199нн////////////////////////////
	//öET199
	DWORD dwRet;
	DWORD dwCount=0;
	ET_CONTEXT *pContext;

	BYTE pbOut[128] = {0};
	DWORD dwOutLen = 0;
	
	dwRet=ETEnum(NULL,&dwCount);

	if(dwRet != ET_E_INSUFFICIENT_BUFFER && dwRet)
		return dwRet;

	//ڴڴ洢CONTEXTṹ
	pContext = new ET_CONTEXT[dwCount];

	//0
	memset(pContext,0,sizeof(ET_CONTEXT)*dwCount);

	//ʹ÷Ļ½ö
	dwRet=ETEnum(pContext,&dwCount);
	if(dwRet)
		return dwRet;

	//printf("Find ET199 %d\n",dwCount);

	//ET199
	dwRet = ETOpen(&pContext[0]);
	if(dwRet)
		return dwRet;

	//ִгǰҪ֤û
	dwRet = ETVerifyPin(&pContext[0], ET_DEFAULT_USER_PIN, ET_USER_PIN_LEN, ET_USER_PIN);
	if(dwRet)
	{
		printf("ETVerifyPin Error:0x%08X\n",dwRet);
		delete [] pContext;
		return dwRet;
	}	

	
	dwRet = ETExecute(&pContext[0],"0001",pbPlainData,128,pbOut,128, &dwOutLen);
	if(dwRet)
	{
		printf("ETExecute Error 1:0x%08X\n",dwRet);
		delete [] pContext;
		return dwRet;
	}

	if(dwOutLen != 128)
	{
		printf("ETExecute Error 2:0x%08X\n",dwOutLen);
		delete [] pContext;
		return dwRet;
	}

	printf("\n\nET199˽ԿԿܽ\n");
	for(i=0; i<128; ++i)
	{
		if(i%16==0)
			printf("\n");
		printf("%02X ", pbOut[i]);
	}		


	ETClose(&pContext[0]);
	delete [] pContext;

	/*---------------------һ̽--------------------------*/


	/*----------ڶ̣ET199˽ԿܣӦйԿ----------------*/
	/*ʹĽӿڣ˽ԿһԵģһܣһܽܣ֮Ҳһ*/
	////////////////////////////////////ʹ˽ԿET199нм////////////////////////////
	printf("\n\n/*----------ڶ̣ET199˽ԿܣӦйԿ----------------*/\n");
	memset(pbPlainData, 0, 128);
	memset(pbOut, 0, 128);
	for(i=0; i<128; ++i)
	{
		pbPlainData[i] = i;
	}

	dwRet=ETEnum(NULL,&dwCount);

	if(dwRet != ET_E_INSUFFICIENT_BUFFER && dwRet)
		return dwRet;

	//ڴڴ洢CONTEXTṹ
	pContext = new ET_CONTEXT[dwCount];

	//0
	memset(pContext,0,sizeof(ET_CONTEXT)*dwCount);

	//ʹ÷Ļ½ö
	dwRet=ETEnum(pContext,&dwCount);
	if(dwRet)
		return dwRet;

	//printf("Find ET199 %d\n",dwCount);

	//ET199
	dwRet = ETOpen(&pContext[0]);
	if(dwRet)
		return dwRet;

	//ִгǰҪ֤û
	dwRet = ETVerifyPin(&pContext[0], ET_DEFAULT_USER_PIN, ET_USER_PIN_LEN, ET_USER_PIN);
	if(dwRet)
	{
		printf("ETVerifyPin Error:0x%08X\n",dwRet);
		delete [] pContext;
		return dwRet;
	}	

	
	dwRet = ETExecute(&pContext[0],"0001",pbPlainData,128,pbOut,128, &dwOutLen);
	if(dwRet)
	{
		printf("ETExecute Error 1:0x%08X\n",dwRet);
		delete [] pContext;
		return dwRet;
	}

	if(dwOutLen != 128)
	{
		printf("ETExecute Error 2:0x%08X\n",dwOutLen);
		delete [] pContext;
		return dwRet;
	}

	printf("ET199˽Կӽܽ\n");
	for(i=0; i<128; ++i)
	{
		if(i%16==0)
			printf("\n");
		printf("%02X ", pbOut[i]);
	}		


	ETClose(&pContext[0]);
	delete [] pContext;


	//ʹùԿн
	ret = RSAData(pbModulus,1024,pbOut,128);
	if(ret == 0)
	{
		printf("\n\nйԿܽ\n");
		for(i=0; i<128; ++i)
		{
			if(i%16==0)
				printf("\n");
			printf("%02X ", pbOut[i]);
		}
	}
	else
	{
		printf("RSAData Error:0x%08X\n", ret);
	}
	
	return 0;
}
